From f306da4dc713a3ea78edc10e0d73d4252cde73a0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 23 2020 06:42:35 +0000
Subject: [PATCH 41/2232] Test c++ calling to rust


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 168261d..098253a 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -79,11 +79,11 @@ fn r_return_rust_string() -> String {
 }
 
 fn r_take_primitive(n: usize) {
-    let _ = n;
+    assert_eq!(n, 2020);
 }
 
 fn r_take_shared(shared: ffi::Shared) {
-    let _ = shared;
+    assert_eq!(shared.z, 2020);
 }
 
 fn r_take_box(r: Box<R>) {
@@ -103,13 +103,13 @@ fn r_take_ref_c(c: &ffi::C) {
 }
 
 fn r_take_str(s: &str) {
-    let _ = s;
+    assert_eq!(s, "2020");
 }
 
 fn r_take_rust_string(s: String) {
-    let _ = s;
+    assert_eq!(s, "2020");
 }
 
 fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
-    let _ = s;
+    assert_eq!(s.as_ref().unwrap().to_str().unwrap(), "2020");
 }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index cfe07ab..d27df41 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -79,4 +79,33 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s) {
   }
 }
 
+extern "C" const char *cxx_run_test() noexcept {
+#define STRINGIFY(x) #x
+#define TOSTRING(x) STRINGIFY(x)
+#define ASSERT(x)                                                              \
+  do {                                                                         \
+    if (!(x)) {                                                                \
+      return "Assertion failed: `" #x "`, " __FILE__ ":" TOSTRING(__LINE__);   \
+    }                                                                          \
+  } while (false)
+
+  ASSERT(r_return_primitive() == 2020);
+  ASSERT(r_return_shared().z == 2020);
+  ASSERT(r_return_ref(Shared{2020}) == 2020);
+  ASSERT(std::string(r_return_str(Shared{2020})) == "2020");
+  ASSERT(std::string(r_return_rust_string()) == "2020");
+
+  r_take_primitive(2020);
+  r_take_shared(Shared{2020});
+  r_take_unique_ptr(std::unique_ptr<C>(new C{2020}));
+  r_take_ref_c(C{2020});
+  r_take_str(cxxbridge::RustStr("2020"));
+  // TODO r_take_rust_string(cxxbridge::RustString("2020"));
+  r_take_unique_ptr_string(
+      std::unique_ptr<std::string>(new std::string("2020")));
+
+  cxx_test_suite_set_correct();
+  return nullptr;
+}
+
 } // namespace tests
diff --git a/tests/test.rs b/tests/test.rs
index 9f595f7..28e5c3b 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -1,5 +1,6 @@
 use cxx_test_suite::ffi;
 use std::cell::Cell;
+use std::ffi::CStr;
 
 thread_local! {
     static CORRECT: Cell<bool> = Cell::new(false);
@@ -10,6 +11,14 @@ extern "C" fn cxx_test_suite_set_correct() {
     CORRECT.with(|correct| correct.set(true));
 }
 
+macro_rules! check {
+    ($run:expr) => {{
+        CORRECT.with(|correct| correct.set(false));
+        $run;
+        assert!(CORRECT.with(|correct| correct.get()), stringify!($run));
+    }};
+}
+
 #[test]
 fn test_c_return() {
     let shared = ffi::Shared { z: 2020 };
@@ -32,14 +41,6 @@ fn test_c_return() {
 
 #[test]
 fn test_c_take() {
-    macro_rules! check {
-        ($run:expr) => {{
-            CORRECT.with(|correct| correct.set(false));
-            $run;
-            assert!(CORRECT.with(|correct| correct.get()), stringify!($run));
-        }};
-    }
-
     let unique_ptr = ffi::c_return_unique_ptr();
 
     check!(ffi::c_take_primitive(2020));
@@ -53,3 +54,18 @@ fn test_c_take() {
         ffi::c_return_unique_ptr_string()
     ));
 }
+
+#[test]
+fn test_c_call_r() {
+    fn cxx_run_test() {
+        extern "C" {
+            fn cxx_run_test() -> *const i8;
+        }
+        let failure = unsafe { cxx_run_test() };
+        if !failure.is_null() {
+            let msg = unsafe { CStr::from_ptr(failure) };
+            eprintln!("{}", msg.to_string_lossy());
+        }
+    }
+    check!(cxx_run_test());
+}

